-- Free form notes per character

function LoadData()
	-- load saved settings
	CharNotes=PatchDataLoad( Turbine.DataScope.Server, "AltViewer_CharNotes");
	if CharNotes==nil then
		CharNotes=PatchDataLoad( Turbine.DataScope.Server, "AltInventory_CharNotes");
	end
	if CharNotes==nil then
		CharNotes={};
	end
end
LoadData()

NotesPanel=Turbine.UI.Control()
NotesPanel:SetMouseVisible(false);
NotesPanel:SetSize(200,200);

NotesPanel.NoteCaption=Turbine.UI.Label();
NotesPanel.NoteCaption:SetParent(NotesPanel);
NotesPanel.NoteCaption:SetSize(100,20);
NotesPanel.NoteCaption:SetPosition(0,0);
NotesPanel.NoteCaption:SetFont(Turbine.UI.Lotro.Font.Verdana16);
NotesPanel.NoteCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
NotesPanel.NoteCaption:SetText(Resource[language][12]);

NotesPanel.NoteBorder=Turbine.UI.Control();
NotesPanel.NoteBorder:SetParent(NotesPanel);
NotesPanel.NoteBorder:SetSize(200,200);
NotesPanel.NoteBorder:SetPosition(0,25);

NotesPanel.NotePad=Turbine.UI.TextBox();
NotesPanel.NotePad:SetParent(NotesPanel.NoteBorder);
NotesPanel.NotePad:SetSize(198,198);
NotesPanel.NotePad:SetPosition(1,1);
NotesPanel.NotePad:SetMultiline(true);
NotesPanel.NotePad:SetFont(Turbine.UI.Lotro.Font.Verdana16);
NotesPanel.NotePad:SetText(CharNotes[charName]);
NotesPanel.LastCharName=charName;

NotesPanel.NoteVScroll=Turbine.UI.Lotro.ScrollBar();
NotesPanel.NoteVScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
NotesPanel.NoteVScroll:SetParent(NotesPanel);
NotesPanel.NoteVScroll:SetPosition(NotesPanel.NotePad:GetWidth(),25);
NotesPanel.NoteVScroll:SetWidth(12);
NotesPanel.NoteVScroll:SetHeight(200);
NotesPanel.NotePad:SetVerticalScrollBar(NotesPanel.NoteVScroll);

NotesPanel:SetVisible(false);

NotesPanel.LoadCharData=function()
	if NotesPanel.LastCharName~=nil then
		CharNotes[NotesPanel.LastCharName]=NotesPanel.NotePad:GetText();
	end
	NotesPanel.LastCharName=selectedCharName;
	NotesPanel.NotePad:SetText(CharNotes[selectedCharName]);

	if NotesPanel.NoteVScroll:IsVisible() then
		-- force scroll to top of note
		NotesPanel.NotePad:SetSelectionStart(0);
		NotesPanel.NotePad:SetSelectionLength(1);
		NotesPanel.NotePad:SetSelectedText(NotesPanel.NotePad:GetSelectedText())
		NotesPanel.NotePad:SetSelectionLength(0);
	end
end

NotesPanel.SaveData=function()
	if NotesPanel.LastCharName~=nil then
		CharNotes[NotesPanel.LastCharName]=NotesPanel.NotePad:GetText();
	end
	PatchDataSave( Turbine.DataScope.Server, "AltViewer_CharNotes",CharNotes);
end
NotesPanel.RemoveCallbacks=function()
end
NotesPanel.RemoveCharacter=function(characterName)
	CharNotes[characterName]=nil;
end
NotesPanel.SizeChanged=function(sender,args)
	local NewWidth,NewHeight=mainWindow.PanelBack:GetSize();
	Turbine.UI.Control.SetSize(NotesPanel,NewWidth,NewHeight);
	NotesPanel.NoteBorder:SetSize(NewWidth-12,NewHeight-35);
	NotesPanel.NotePad:SetSize(NewWidth-14,NewHeight-37);
	NotesPanel.NoteVScroll:SetLeft(NewWidth-12);
	NotesPanel.NoteVScroll:SetHeight(NewHeight-35);
	NotesPanel.NoteCaption:SetWidth(NewWidth);
end
NotesPanel.SetLanguage=function()
	NotesPanel.NoteCaption:SetText(Resource[language][12]);
end
NotesPanel.SetColors=function()
	NotesPanel:SetBackColor(settings.BackColor);
	NotesPanel.NoteVScroll:SetBackColor(settings.BackColor);
	NotesPanel.NoteCaption:SetForeColor(settings.HeadingsColor);
	NotesPanel.NoteBorder:SetBackColor(settings.TrimColor);
	NotesPanel.NotePad:SetForeColor(settings.ForeColor);
	NotesPanel.NotePad:SetBackColor(settings.BackColor);
end
